﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using Task;

namespace StartAuto
{
    class Program
    {
        static Point pos;
        static Vector speed;
        static double fuel;
        static string engineRight, engineLeft, engineBottom;

        static void Main(string[] args)
        {
            args = new string[] { "http://127.0.0.1:8000", "0" };

            Settings.Uri = new Uri(args[0], UriKind.Absolute);
            Settings.MaxSpeed = double.Parse(args[1].Replace('.', ','));

            engineBottom = "nahoru=0";
            engineLeft = "doprava=0";
            engineRight = "doleva=0";

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(new Uri(Settings.Uri, "/start"));

            using (WebResponse response = req.GetResponse())
            using (StreamReader sr = new StreamReader(response.GetResponseStream()))
            {


                string[] pars = sr.ReadToEnd().Replace('.', ',').Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);


                Settings.Id = uint.Parse(pars[0]);

                string[] posMod = pars[1].Split(' ');

                pos = new Point(double.Parse(posMod[0]), double.Parse(posMod[1]));

                string[] velocity = pars[2].Split(' ');

                speed = new Vector(double.Parse(velocity[0]), double.Parse(velocity[1]));

                fuel = double.Parse(pars[3]);

                string[] posLand = pars[4].Split(' ');
                Settings.LandingPoint = new Point((double.Parse(posLand[0]) + double.Parse(posLand[1])) / 2.0, 0);

            }
            while (true)
                Update();
        }

        static void Update()
        {
            DateTime start = DateTime.Now;

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(new Uri(Settings.Uri, "/stav?id=" + Settings.Id + "&" + engineBottom + "&" + engineLeft + "&" + engineRight));


            Console.WriteLine(pos);
            Console.WriteLine(Settings.LandingPoint);
            using (WebResponse response = req.GetResponse())
            using (StreamReader sr = new StreamReader(response.GetResponseStream()))
            {
                string[] pars = sr.ReadToEnd().Replace('.', ',').Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);

                if (pars.Length == 1)
                {
                    return;
                }
                Settings.Id = uint.Parse(pars[0]);

                string[] posMod = pars[1].Split(' ');

                pos = new Point(double.Parse(posMod[0]), double.Parse(posMod[1]));

                string[] velocity = pars[2].Split(' ');

                speed = new Vector(double.Parse(velocity[0]), double.Parse(velocity[1]));

                fuel = double.Parse(pars[3]);
            }

            double sleepTime = 500.0 - (DateTime.Now - start).TotalMilliseconds;
            if (sleepTime > 0)
                Thread.Sleep((int)sleepTime);

            engineLeft = "doprava=0";
            engineRight = "doleva=0";

            double seconds = ((DateTime.Now - start).TotalMilliseconds / 1000.0);
            double velY = speed.Y - 7 * seconds;
            if (velY <= -4.8)
                engineBottom = "nahoru=1";
            else
                engineBottom = "nahoru=0";

            if (pos.X - Settings.StartingPosition.X < 8)
            {
                double velX = speed.X;
                if (Math.Abs(velX) < 4)
                    engineLeft = "doleva=1";
                else
                    engineLeft = "doleva=0";

                if (velX < -4.8)
                    engineLeft = "doprava=1";

                if (velX > 4.8)
                    engineRight = "doleva=1";
            }
            else if (pos.X - Settings.StartingPosition.X > 8)
            {

                double velX = speed.X;
                if (Math.Abs(velX) < 4)
                    engineRight = "doprava=1";
                else
                    engineRight = "doprava=0";

                if (velX > 4.8)
                    engineRight = "doleva=1";
                if (velX < -4.8)
                    engineLeft = "doprava=1";

            }
            else
            {
                engineLeft = "doprava=0";
                engineRight = "doleva=0";
            }


        }
    }
}
