﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace Task
{
    public class Lander
    {
        Brush brush;
        Point position;
        Point relPos;
        Size size;

        Rectangle rect;
        Canvas canvas;
        double sizeRatio;
        Vector velocity;
        Line velocityLine;

        public Lander(Brush brush, Point pos, Size size, Canvas canvas, double sizeRatio)
        {
            this.brush = brush;
            this.size = size;
            this.position = pos;
            this.canvas = canvas;

            rect = new Rectangle();
            SizeRatio = sizeRatio;
            rect.Fill = brush;

            velocityLine = new Line();
            velocityLine.Stroke = Brushes.Blue;
            velocityLine.StrokeThickness = 5;

            canvas.Children.Add(velocityLine);
            canvas.Children.Add(rect);
        }

        public Point Position
        {
            get
            {
                return position;
            }
            set
            {
                position = value;
            }
        }

        public Vector Velocity
        {
            get { return velocity; }
            set { velocity = value; }
        }

        public Point RelativePosition
        {
            get { return relPos; }
            set
            {
                relPos = value;
                Canvas.SetLeft(rect, ((value.X - size.Width / 2) * SizeRatio) + canvas.ActualWidth / 2);
                Canvas.SetTop(rect, canvas.ActualHeight - (value.Y - 10) * SizeRatio - rect.Height);

                Point center = new Point((value.X * SizeRatio) + (canvas.ActualWidth / 2), canvas.ActualHeight - 5 - (value.Y * SizeRatio));
                velocityLine.X1 = center.X;
                velocityLine.Y1 = center.Y;

                velocityLine.X2 = center.X + (velocity.X * SizeRatio);
                velocityLine.Y2 = center.Y - (velocity.Y * SizeRatio);

            }
        }

        public double SizeRatio
        {
            get
            {
                return sizeRatio;
            }
            set
            {
                sizeRatio = value;
                rect.Width = size.Width * value;
                rect.Height = size.Height * value;
            }
        }

        public Point Offset { get; set; }

        public bool LeftEngine { get; set; }
        public bool RightEngine { get; set; }
        public bool BottomEngine { get; set; }
    }
}
